//Mandelbrot exploration, colored version (slow)
//(c) Loe Feijs and TU/e, 2016, for DGM211, Golden ratio
//F is the iterated function, escapes if modulus is more than two.

Complex  F(Complex c, int n){
         if (n == 0)
             return new Complex(0,0);
         else if (c.modulus() > 2)
                  return c;
         else {   Complex z = F(c,n - 1);
                  return z.mul(z).add(c);
         }
}   

void setup(){
     frameRate(400);
     size(displayWidth,displayHeight);
     //or try size(400,400);
     background(0);
     scale = height / 2;
}



int x = 0;
float scale;
int iterations = 1;
void draw(){
     x++;
     if (x == width){
         x = 0;
         iterations++;
     }
     //(float x = 0; x < width; x++) via draw()
          for (float y = 0; y < height; y++){
               float zx = (x + - width/2) / scale -.5 ;
               float zy = (y  - height/2) / scale ;
               Complex zn = F(new Complex(zx,zy),iterations);
               if (zn.modulus() < 2)  {
                 //the more iterations, the more red, the less green, blue
                  int BLUE   = min(255,6*iterations);
                  int GREEN = max(0,255-iterations*iterations);
                  int RED  = max(0,255-6*iterations);
                  stroke(RED,GREEN,BLUE);
                  point(x,y);
               } 
          }
      if (x == 0) println(int(100.0 * (6.0 * iterations / 255.0)) + "%");
      if (6*iterations > 255) println("READY, THANKS FOR YOUR PATIENCE");
}
